% Plot bode plots
% 
%   ----------------------------------------------------------------------------
%   Copyright 2023 Vaibhav Gupta, DDMAC, EPFL (MIT License)
%

%% Normal Controller
for readout_noise = [true, false]
    if readout_noise
        extra_caption = "using detector with readout noise";
        extra_label = "readout";
    else
        extra_caption = "using detector without any readout noise";
        extra_label = "no_readout";
    end

    for n_photons = [16, 160, 1600]
        compare_controllers( ...
            "Fs", 400, ...
            "n_photons", n_photons, ...
            "readout_noise", readout_noise, ...
            "extra_disturbance_type_design", "none", ...
            "extra_disturbance_type_sim", "none", ...
            "extra_disturbance_rms", 5, ...
            "save_plot", true, ...
            "plot_folder", fullfile( ...
                "figures", ...
                "bodes", ...
                "closed-loop"), ...
            "short_caption", sprintf( ...
                "Closed-loop performance of the controller %s at sampling frequency of \\SI{400}{\\hertz} with \\SI{%d}{} photons per timestep", ...
                extra_caption, n_photons), ...
            "caption", sprintf( ...
                "Closed-loop performance of the controller %s at sampling frequency of \\SI{400}{\\hertz} with \\SI{%d}{} photons per timestep", ...
                extra_caption, n_photons), ...
            "label", sprintf("400Hz_%dphotons_%s", n_photons, extra_label));
    end
end

%% Narrowband Sinusoidal Disturbance
for readout_noise = [true, false]
    if readout_noise
        extra_caption = "using detector with readout noise";
        extra_label = "readout";
    else
        extra_caption = "using detector without any readout noise";
        extra_label = "no_readout";
    end

    compare_controllers( ...
        "Fs", 400, ...
        "n_photons", 1600, ...
        "readout_noise", readout_noise, ...
        "extra_disturbance_type_design", "none", ...
        "extra_disturbance_type_sim", "narrowband", ...
        "extra_disturbance_rms", 5, ...
        "save_plot", true, ...
        "plot_folder", fullfile( ...
            "figures", ...
            "bodes", ...
            "narrowband"), ...
        "short_caption", sprintf( ...
            "Closed-loop performance under an unknown narrowband disturbance %s", ...
                extra_caption), ...
        "caption", sprintf( ...
            "Closed-loop performance under an unknown narrowband disturbance %s at sampling frequency of \\SI{400}{\\hertz} with \\SI{1600}{} photons per timestep", ...
                extra_caption), ...
        "label", sprintf("narrowband_unknown_%s", extra_label));

    compare_controllers( ...
        "Fs", 400, ...
        "n_photons", 1600, ...
        "readout_noise", readout_noise, ...
        "extra_disturbance_type_design", "narrowband", ...
        "extra_disturbance_type_sim", "narrowband", ...
        "extra_disturbance_rms", 5, ...
        "save_plot", true, ...
        "plot_folder", fullfile( ...
            "figures", ...
            "bodes", ...
            "narrowband"), ...
        "short_caption", sprintf( ...
            "Closed-loop performance under a known narrowband disturbance %s", ...
                extra_caption), ...
        "caption", sprintf( ...
            "Closed-loop performance under a known narrowband disturbance %s at sampling frequency of \\SI{400}{\\hertz} with \\SI{1600}{} photons per timestep", ...
                extra_caption), ...
        "label", sprintf("narrowband_known_%s", extra_label));

    compare_controllers( ...
        "Fs", 400, ...
        "n_photons", 1600, ...
        "readout_noise", readout_noise, ...
        "extra_disturbance_type_design", "narrowband", ...
        "extra_disturbance_type_sim", "none", ...
        "extra_disturbance_rms", 5, ...
        "save_plot", true, ...
        "plot_folder", fullfile( ...
            "figures", ...
            "bodes", ...
            "narrowband"), ...
        "short_caption", sprintf( ...
            "Closed-loop performance under a wrong narrowband disturbance %s", ...
                extra_caption), ...
        "caption", sprintf( ...
            "Closed-loop performance under a wrong narrowband disturbance %s at sampling frequency of \\SI{400}{\\hertz} with \\SI{1600}{} photons per timestep", ...
                extra_caption), ...
        "label", sprintf("narrowband_wrong_%s", extra_label));
end

%% Chirp Disturbance
for readout_noise = [true, false]
    if readout_noise
        extra_caption = "using detector with readout noise";
        extra_label = "readout";
    else
        extra_caption = "using detector without any readout noise";
        extra_label = "no_readout";
    end

    compare_controllers( ...
        "Fs", 400, ...
        "n_photons", 1600, ...
        "readout_noise", readout_noise, ...
        "extra_disturbance_type_design", "none", ...
        "extra_disturbance_type_sim", "chirp", ...
        "extra_disturbance_rms", 5, ...
        "save_plot", true, ...
        "plot_folder", fullfile( ...
            "figures", ...
            "bodes", ...
            "chirp"), ...
        "short_caption", sprintf( ...
            "Closed-loop performance under a chirp disturbance %s", ...
                extra_caption), ...
        "caption", sprintf( ...
            "Closed-loop performance under a chirp disturbance %s at sampling frequency of \\SI{400}{\\hertz} with \\SI{1600}{} photons per timestep", ...
                extra_caption), ...
        "label", sprintf("chirp_%s", extra_label));
end
